<?php
/* gvHIDRA. Herramienta Integral de Desarrollo Rpido de Aplicaciones de la Generalitat Valenciana
*
* Copyright (C) 2006 Generalitat Valenciana.
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,USA.
*
* For more information, contact:
*
*  Generalitat Valenciana
*  Conselleria d'Infraestructures i Transport
*  Av. Blasco Ibez, 50
*  46010 VALENCIA
*  SPAIN
*  +34 96386 24 83
*  gvhidra@gva.es
*  www.gvpontis.gva.es
*
*/ 


/**
 * gvHidraString contiene informacin relativa a los campos de tipo cadena 
 *
 *
 * @version $Id: gvHidraString.php,v 1.12 2010/03/08 18:11:37 afelixf Exp $
 * 
 * @author Toni: <felix_ant@gva.es>
 *
 * @package gvHIDRA
 */ 
class gvHidraString extends gvHidraTypeBase
{
    
    private $regExp;
    private $inputMask;


	/**
	* Crear un tipo gvHidraString (String).
	* @access	public
	* @param	required	boolean		true campo obligatorio, false campo no obligatorio	 
	* @param	maxlength	integer		longitud mxima del campo
	* @return	none
	*/    
    public function __construct($required=false,$maxLength=null){
    	parent::__construct($required,$maxLength);
	   	//Inicializamos atributos de la clase
    	$this->setRegExp(null);
    	$this->setInputMask(null);
    }//Fin de constructor

	/**
	* Fija una expresin regular de validacin de la cadena.
	* @access	public
	* @param	string	expresin regular
	* @return	none
	*/	
	final public function setRegExp($value){
		$this->regExp = $value;
	}
	
	final public function getRegExp(){
		return $this->regExp;
	}

	/**
	* Fija una mscara de entrada de datos segn la codificacin de gvHidra.
	* @access	public
	* @param	string	mscara de entrada
	* @return	none
	*/	
	final public function setInputMask($value){
		$this->inputMask = $value;
	}
	
	final public function getInputMask(){
		return $this->inputMask; 
	}
	
	public function validate($value){
		if(parent::validate($value)==0){
			$regExpr = $this->getRegExp();
			if(!empty($regExpr) and !empty($value)){
				if (ereg($this->getRegExp(),$value))
					return 0;
				else
					throw new Exception('No es del formato correcto.');
			}
			return 0;
		}
	}
		
}//Fin clase gvHidraString
?>